#include "Vram.h"
#include "VVram.h"
#include "CopyMemory.h"
#include "Chars.h"

extern const byte[] Chars;

byte[256] CharColors;

static const byte[] ColorSource = {
    Char_Logo, 25, 0x5D,
    Char_Ladder_Left, 2, 0x61,
    Char_Monster, 32, 0x54,
    Char_Item, 4, 0x77,
    0xff
};

static void SetColor(ptr<byte> pColor, byte color, byte count)
{
    do {
        *pColor = color;
        ++pColor;
        --count;
    } while (count != 0);
}


void InitVram()
{
    ptr<byte> pColor, pSource;

    pColor = CharColors;
    repeat (0) {
        *pColor = 0x71;
        ++pColor;
    }

    pSource = ColorSource;
    while (pSource[0] != 0xff) {
        byte count, color;
        pColor = CharColors + pSource[0];
        count = pSource[1];
        color = pSource[2];
        pSource += 3;
        do {
            *pColor = color;
            ++pColor;
            --count;
        } while (count > 0);
    }
    CopyMemory(PatternRam, Chars, Char_End * PatternSize);
}


void ClearScreen()
{
    FillMemory(Vram, VramRowSize * VramHeight, Char_Space);
    FillMemory(ColorMap, VramRowSize * VramHeight, 0x7f);
}


ptr<byte> PrintC(ptr<byte> pVram, byte c)
{
    return Put(pVram, c - ' ');
}


void Put2C(ptr<byte> pVram, byte c)
{
    repeat (2) {
        repeat (2) {
            pVram = Put(pVram, c);
            ++c;
        }
        pVram += VramWidth - 2;
    }
}
